        subroutine compute_born(pin, m2i0)
          use recola, only: compute_process_rcl
          use quarklabels
          implicit none
#include "mcparams.h"
#include "mcinput.h"
#include "mccommon.h"
          real(kind (23d0)), intent(in) :: pin(5,0:3)
          real(kind (23d0)), intent(inout) :: m2i0(-5:5,-5:5)
          real(kind (23d0)) :: p(0:3,5), k(0:3,5)
          real(kind (23d0)) :: matrix2(2),sth,cth
          logical           :: CKM_nondiagonal

          m2i0 = 0d0
          if (sinthetacin .ne. 0d0) then
            CKM_nondiagonal = .true.
            sth = sinthetacin
            cth = cos(asin(sinthetacin))
          else
            CKM_nondiagonal = .false.
          end if
          p(:,1) = pin(1,:)
          p(:,2) = pin(2,:)
          p(:,3) = pin(3,:)
          p(:,4) = pin(4,:)
          p(:,5) = pin(5,:)
          call compute_process_rcl(1, p, "LO", matrix2)
          m2i0(in11,in12) = 36d0*matrix2(1)
          if (n_in_states .eq. 4) then
            call compute_process_rcl(2, p, "LO", matrix2)
          end if
          m2i0(in21,in22) = 36d0*matrix2(1)

          ! only for non-diagonal CKM
          if (CKM_nondiagonal .and. n_in_states .ne. 4) then
            m2i0(in21,in12) = m2i0(in11,in12)*sth**2
            m2i0(in11,in22) = m2i0(in21,in22)*sth**2
            m2i0(in11,in12) = m2i0(in11,in12)*cth**2
            m2i0(in21,in22) = m2i0(in21,in22)*cth**2
          end if

          if (n_in_states .eq. 4) then
            call compute_process_rcl(41, p, "LO", matrix2)
            m2i0(in31,in32) = 36d0*matrix2(1)
            call compute_process_rcl(42, p, "LO", matrix2)
            m2i0(in41,in42) = 36d0*matrix2(1)
            if (sbini .eq. 1) then
              call compute_process_rcl(101, p, "LO", matrix2)
              m2i0(-5,5) = 36d0*matrix2(1)
            end if
          end if

          ! interchange the incoming quarks
          k(:,1) = p(:,2)
          k(:,2) = p(:,1)
          k(:,3:) = p(:,3:)
          call compute_process_rcl(1, k, "LO", matrix2)
          m2i0(in12,in11) = 36d0*matrix2(1)
          if (n_in_states .eq. 4) then
            call compute_process_rcl(2, k, "LO", matrix2)
          end if
          m2i0(in22,in21) = 36d0*matrix2(1)

          ! only for non-diagonal CKM
          if (CKM_nondiagonal .and. n_in_states .ne. 4) then
            m2i0(in12,in21) = m2i0(in12,in11)*sth**2
            m2i0(in22,in11) = m2i0(in22,in21)*sth**2
            m2i0(in12,in11) = m2i0(in12,in11)*cth**2
            m2i0(in22,in21) = m2i0(in22,in21)*cth**2
          end if

          if (n_in_states .eq. 4) then
            call compute_process_rcl(41, k, "LO", matrix2)
            m2i0(in32, in31) = 36d0*matrix2(1)
            call compute_process_rcl(42, k, "LO", matrix2)
            m2i0(in42,in41) = 36d0*matrix2(1)
            if (sbini .eq. 1) then
              call compute_process_rcl(101, k, "LO", matrix2)
              m2i0(5,-5) = 36d0*matrix2(1)
            end if
          end if
          
        end subroutine compute_born

