        subroutine compute_photon_emission_vbf(pin, m2i0, m2if0)
          use recola
          implicit none
          real(kind (23d0)), intent(in) :: pin(6,0:3)
          real(kind (23d0)), intent(inout) :: m2i0(-5:5,-5:5)
          real(kind (23d0)), intent(inout) :: m2if0(-5:5,-5:5,-5:5,-5:5)
          real(kind (23d0)) :: matrix2(2)
          real(kind (23d0)) :: p(0:3,6),k(0:3,6),q(0:3,6),r(0:3,6)

          p(:,1) = pin(1,:)
          p(:,2) = pin(2,:)
          p(:,3) = pin(3,:)
          p(:,4) = pin(4,:)
          p(:,5) = pin(5,:)
          p(:,6) = pin(6,:)

C          1 <-> 2
          k(:,1) = p(:,2)
          k(:,2) = p(:,1)
          k(:,3:) = p(:,3:)

C          3 <-> 4
          q(:,1) = p(:,1)
          q(:,2) = p(:,2)
          q(:,3) = p(:,4)
          q(:,4) = p(:,3)
          q(:,5:) = p(:,5:)

C          1 <-> 2 && 3 <-> 4
          r(:,1:2) = k(:,1:2)
          r(:,3:4) = q(:,3:4)
          r(:,5:) = p(:,5:)

#include "vbf/compute_phot_emission.f90"

        end subroutine compute_photon_emission_vbf

        subroutine compute_gluon_emission_vbf(pin, m2i0, m2if0)
          use recola
          implicit none
          real(kind (23d0)), intent(in) :: pin(6,0:3)
          real(kind (23d0)), intent(inout) :: m2i0(-5:5,-5:5)
          real(kind (23d0)), intent(inout) :: m2if0(-5:5,-5:5,-5:5,-5:5)
          real(kind (23d0)) :: matrix2(2)
          real(kind (23d0)) :: p(0:3,6),k(0:3,6),q(0:3,6),r(0:3,6)

          p(:,1) = pin(1,:)
          p(:,2) = pin(2,:)
          p(:,3) = pin(3,:)
          p(:,4) = pin(4,:)
          p(:,5) = pin(5,:)
          p(:,6) = pin(6,:)

C          1 <-> 2
          k(:,1) = p(:,2)
          k(:,2) = p(:,1)
          k(:,3:) = p(:,3:)

C          3 <-> 4
          q(:,1) = p(:,1)
          q(:,2) = p(:,2)
          q(:,3) = p(:,4)
          q(:,4) = p(:,3)
          q(:,5:) = p(:,5:)

C          1 <-> 2 && 3 <-> 4
          r(:,1:2) = k(:,1:2)
          r(:,3:4) = q(:,3:4)
          r(:,5:) = p(:,5:)

#include "vbf/compute_gluon_emission.f90"

        end subroutine compute_gluon_emission_vbf

        subroutine compute_photon_induced1_vbf(pin, m2i0_phot,
     &                                         m2if0_phot)
          use recola
          implicit none
          real(kind (23d0)), intent(in) :: pin(6,0:3)
          real(kind (23d0)) :: p(0:3,6),q(0:3,6)
          real(kind (23d0)), intent(inout) :: m2i0_phot(-5:5)
          real(kind (23d0)), intent(inout) :: m2if0_phot(-5:5, -5:5,
     &                                                   -5:5, -5:5)
          real(kind (23d0)) :: matrix2(2)

          p(:,1) = pin(1,:)
          p(:,2) = pin(2,:)
          p(:,3) = pin(3,:)
          p(:,4) = pin(4,:)
          p(:,5) = pin(5,:)
          p(:,6) = pin(6,:)

          q(:,1:2) = p(:,1:2)
          q(:,3)   = p(:,4)
          q(:,4)   = p(:,3)
          q(:,5:)  = p(:,5:)

#include "vbf/compute_phot1.f90"
 
        end subroutine compute_photon_induced1_vbf

        subroutine compute_photon_induced2_vbf(pin, m2i0_phot,
     &                                         m2if0_phot)
          use recola
          implicit none
          real(kind (23d0)), intent(in) :: pin(6,0:3)
          real(kind (23d0)) :: p(0:3,6),k(0:3,6),r(0:3,6)
          real(kind (23d0)), intent(inout) :: m2i0_phot(-5:5)
          real(kind (23d0)), intent(inout) :: m2if0_phot(-5:5, -5:5,
     &                                                   -5:5, -5:5)
          real(kind (23d0)) :: matrix2(2)

          p(:,1) = pin(1,:)
          p(:,2) = pin(2,:)
          p(:,3) = pin(3,:)
          p(:,4) = pin(4,:)
          p(:,5) = pin(5,:)
          p(:,6) = pin(6,:)

C          processes are defined for photon coming from position 1 
C          -> swap p1, p2
          k(:,1)  = p(:,2)
          k(:,2)  = p(:,1)
          k(:,3:) = p(:,3:)

          r(:,1:2) = k(:,1:2)
          r(:,3)   = p(:,4)
          r(:,4)   = p(:,3)
          r(:,5:)  = p(:,5:)

#include "vbf/compute_phot2.f90"
        
        end subroutine compute_photon_induced2_vbf

        subroutine compute_gluon_induced1_vbf(pin, m2i0_gluon,
     &    m2if0_gluon)
          use recola
          implicit none
          real(kind (23d0)), intent(in) :: pin(6,0:3)
          real(kind (23d0)) :: p(0:3,6),q(0:3,6)
          real(kind (23d0)), intent(inout) :: m2i0_gluon(-5:5)
          real(kind (23d0)), intent(inout) :: m2if0_gluon(-5:5, -5:5,
     &                                                   -5:5, -5:5)
          real(kind (23d0)) :: matrix2(2)

          p(:,1) = pin(1,:)
          p(:,2) = pin(2,:)
          p(:,3) = pin(3,:)
          p(:,4) = pin(4,:)
          p(:,5) = pin(5,:)
          p(:,6) = pin(6,:)

          q(:,1:2) = p(:,1:2)
          q(:,3)   = p(:,4)
          q(:,4)   = p(:,3)
          q(:,5:)  = p(:,5:)

#include "vbf/compute_gluon1.f90"

          end subroutine compute_gluon_induced1_vbf

        subroutine compute_gluon_induced2_vbf(pin, m2i0_gluon,
     &    m2if0_gluon)
          use recola
          implicit none
          real(kind (23d0)), intent(in) :: pin(6,0:3)
          real(kind (23d0)) :: p(0:3,6),k(0:3,6),r(0:3,6)
          real(kind (23d0)), intent(inout) :: m2i0_gluon(-5:5)
          real(kind (23d0)), intent(inout) :: m2if0_gluon(-5:5, -5:5,
     &                                                   -5:5, -5:5)
          real(kind (23d0)) :: matrix2(2)

          p(:,1) = pin(1,:)
          p(:,2) = pin(2,:)
          p(:,3) = pin(3,:)
          p(:,4) = pin(4,:)
          p(:,5) = pin(5,:)
          p(:,6) = pin(6,:)

C          processes are defined for photon coming from position 1 
C          -> swap p1, p2
          k(:,1)  = p(:,2)
          k(:,2)  = p(:,1)
          k(:,3:) = p(:,3:)

          r(:,1:2) = k(:,1:2)
          r(:,3)   = p(:,4)
          r(:,4)   = p(:,3)
          r(:,5:)  = p(:,5:)

#include "vbf/compute_gluon2.f90"

        end subroutine compute_gluon_induced2_vbf
