        subroutine init_vbf
          use recola, only: define_process_rcl,
     &                      unselect_power_LoopAmpl_rcl
          implicit none

#include "mcinput.h"
#include "mcparams.h"
#include "mccommon.h"
          character(len=30) :: process
          character(len=2) :: H

          ! setting higgs flavor
          H = trim(adjustl(higgsflavor))

C          if (sweak .eq. 1) then
C          virtual EW
#include "vbf/define_virtEW2.f90"
C          end if

          if (sqcd .eq. 1) then
C          virtual QCD
#include "vbf/define_virtQCD2.f90"
          end if

          if (sborn(0) .eq. 1) then
C          Born 
#include "vbf/definepr.f90"
          end if

          if (spinc(0) .eq. 1) then
C          Photon induced
#include "vbf/define_phot.f90"
          end if

          if (sginc(0) .eq. 1) then
C          Gluon induced
#include "vbf/define_gluon.f90"
          end if

          if (spbrems(0) .eq. 1) then
C          photon emission
#include "vbf/define_phot_emission.f90"
          end if

          if (sgbrems(0) .eq. 1) then
C          Gluon emission
#include "vbf/define_gluon_emission.f90"
          end if

        end subroutine init_vbf

!----------------------------------------------------------------------!
        subroutine init_higgs_strahlung(selprocess)
!----------------------------------------------------------------------!
          use recola, only: define_process_rcl,  
     &                      unselect_power_LoopAmpl_rcl
          use quarklabels, only: init_quarkindices
          implicit none

#include "mcinput.h"
#include "mcparams.h"
#include "mccommon.h"
          integer, intent(in) :: selprocess
          ! in_{ij} + quark j in  quark combination i
          character(len=5) :: in11, in12  ! d~ u as combination 1
          character(len=5) :: out11, out12  ! antiparitcles of 1
          character(len=5) :: in21, in22  ! s~ c as combination 1
          character(len=5) :: out21, out22  ! antiparitcles of 2

          character(len=5) :: in31, in32  
          character(len=5) :: out31, out32
          character(len=5) :: in41, in42
          character(len=5) :: out41, out42

          character(len=5) :: in11anti, in12anti, in21anti, in22anti

          character(len=5) :: in31anti, in32anti, in41anti, in42anti

          character(len=10) :: in1, in2
          character(len=10) :: in1a1, in1a2, in1g1, in1g2
          character(len=10) :: in2a1, in2a2, in2g1, in2g2

          character(len=10) :: in3, in4
          character(len=10) :: in3a1, in3a2, in3g1, in3g2
          character(len=10) :: in4a1, in4a2, in4g1, in4g2

          character(len=20) :: out, outa, outg

          character(len=30) :: process

          character(len=2) :: H

          integer :: n_in_states

          call init_quarkindices(selprocess)

          ! setting higgs flavor
          H = trim(adjustl(higgsflavor))

!====================!
!  p p -> l+  nu  H  !
!====================!
          if (selprocess .eq. 1) then
            n_in_states = 2
            in11 = 'd~'
            in12 = 'u'
            out11 = 'd'
            out12 = 'u~'

            in21 = 's~'
            in22 = 'c'
            out21 = 's'
            out22 = 'c~'

            out = 'e+ nu_e ' // H
          else if (selprocess .eq. 2) then
            n_in_states = 2
            in11 = 'u~'
            in12 = 'd'
            out11 = 'u'
            out12 = 'd~'

            in21 = 'c~'
            in22 = 's'
            out21 = 'c'
            out22 = 's~'

            out = 'nu_e~ e- ' // H
          else if (selprocess .eq. 3) then
            n_in_states = 4

            in11 = 'u~'
            in12 = 'u'
            out11 = 'u'
            out12 = 'u~'

            in21 = 'd~'
            in22 = 'd'
            out21 = 'd'
            out22 = 'd~'

            in31 = 'c~'
            in32 = 'c'
            out31 = 'c'
            out32 = 'c~'

            in41 = 's~'
            in42 = 's'
            out41 = 's'
            out42 = 's~'

            out = 'e+ e- ' // H
          else if (selprocess .eq. 4) then
            n_in_states = 4

            in11 = 'u~'
            in12 = 'u'
            out11 = 'u'
            out12 = 'u~'

            in21 = 'd~'
            in22 = 'd'
            out21 = 'd'
            out22 = 'd~'

            in31 = 'c~'
            in32 = 'c'
            out31 = 'c'
            out32 = 'c~'

            in41 = 's~'
            in42 = 's'
            out41 = 's'
            out42 = 's~'

            out = 'nu_e~ nu_e ' // H
          else
            write (*, *) 'process class: ', selprocess,
     &                   ' not defined.'
            stop
          end if

!========================!
!  Define inital states  !
!========================!

!===================!
!  initial class 1  !
!===================!
          in1 = trim(in11)//' '//in12

          ! photon induced
          in1a1 = 'A'//' '//in12
          in1a2 = trim(in11)//' A'

          ! gluon induced
          in1g1 = 'g'//' '//in12
          in1g2 = trim(in11)//' g'


!===================!
!  initial class 2  !
!===================!
          in2 = trim(in21)//' '//in22

          ! photon induced
          in2a1 = 'A'//' '//in22
          in2a2 = trim(in21)//' A'

          ! gluon induced
          in2g1 = 'g'//' '//in22
          in2g2 = trim(in21)//' g'

!=========================!
!  further inital states  !
!=========================!

          if (n_in_states .eq. 4) then
            in3 = trim(in31)//' '//in32
            in4 = trim(in41)//' '//in42
            ! photon induced
            in3a1 = 'A'//' '//in32
            in3a2 = trim(in31)//' A'
            in4a1 = 'A'//' '//in42
            in4a2 = trim(in41)//' A'
          ! gluon induced
            in3g1 = 'g'//' '//in32
            in3g2 = trim(in31)//' g'
            in4g1 = 'g'//' '//in42
            in4g2 = trim(in41)//' g'
          end if

!==============!
!  Radiations  !
!==============!

          outa = trim(out) // ' A'
          outg = trim(out) // ' g'

C          if (sweak .eq. 1) then
C            virtual ew corrections
          process = trim(in1)//' -> '//out
          call define_process_rcl(35,process,'NLO')
          call unselect_power_LoopAmpl_rcl(35,'QCD',2)
          process = trim(in2)//' -> '//out
          call define_process_rcl(36,process,'NLO')
          call unselect_power_LoopAmpl_rcl(36,'QCD',2)
C          end if

          if (sqcd .eq. 1) then
C            virtual qcd corrections
          process = trim(in1)//' -> '//out
          call define_process_rcl(37,process,'NLO')
          call unselect_power_LoopAmpl_rcl(37,'QED',5)
          process = trim(in2)//' -> '//out
          call define_process_rcl(38,process,'NLO')
          call unselect_power_LoopAmpl_rcl(38,'QED',5)
          end if

          if (sborn(0) .eq. 1) then
C            only born
          process = trim(in1)//' -> '//out
          call define_process_rcl(1, process, 'LO')
          process = trim(in2)//' -> '//out
          call define_process_rcl(2,process,'LO')

          if ((selprocess .eq. 3 .or. selprocess .eq. 4) .and. (sbini .eq. 1)) then
            process = 'b~ b -> '//out
            call define_process_rcl(101,process,'LO')
          end if
          end if

          if (spbrems(0) .eq. 1) then
C            photon radiation
          process = trim(in1)//' -> '//outa
          call define_process_rcl(4,process,'LO')
          process = trim(in2)//' -> '//outa
          call define_process_rcl(5,process,'LO')
          end if

          if (sgbrems(0) .eq. 1) then
C            Gluon radiation
          process = trim(in1)//' -> '//outg
          call define_process_rcl(8,process,'LO')
          process = trim(in2)//' -> '//outg
          call define_process_rcl(9,process,'LO')
          end if

          if (spinc(0) .eq. 1) then
C            Photon 1 induced
          process = trim(in1a1)//' -> '//trim(out)//' '//out11
          call define_process_rcl(10,process,'LO')

          process = trim(in2a1)//' -> '//trim(out)//' '//out21
          call define_process_rcl(11,process,'LO')

C            Photon 2 induced
          process = trim(in1a2)//' -> '//trim(out)//' '//out12
          call define_process_rcl(14,process,'LO')
          process = trim(in2a2)//' -> '//trim(out)//' '//out22
          call define_process_rcl(15,process,'LO')

          if (selprocess .eq. 1 .or. selprocess .eq. 2) then
            call define_process_rcl(411,'u~ e+ -> d~ nu_e~ ' //H,'LO')
            call define_process_rcl(412,'d e+ -> u nu_e~ ' //H,'LO')
            call define_process_rcl(413,'u e- -> d nu_e ' //H,'LO')
            call define_process_rcl(414,'d~ e- -> u~ nu_e ' //H,'LO')
          end if

          end if

          if (sginc(0) .eq. 1) then
C            Gluon 1 induced
          process = trim(in1g1)//' -> '//trim(out)//' '//out11
          call define_process_rcl(18,process,'LO')
          process = trim(in2g1)//' -> '//trim(out)//' '//out21
          call define_process_rcl(19,process,'LO')

C            Gluon 2 induced
          process = trim(in1g2)//' -> '//trim(out)//' '//out12
          call define_process_rcl(22,process,'LO')
          process = trim(in2g2)//' -> '//trim(out)//' '//out22
          call define_process_rcl(23,process,'LO')
          end if


          if (n_in_states .eq. 4) then
C            only born

            if (sborn(0) .eq. 1) then
            process = trim(in3)//' -> '//out
            call define_process_rcl(41, process, 'LO')
            process = trim(in4)//' -> '//out
            call define_process_rcl(42,process,'LO')
            end if

            if (spbrems(0) .eq. 1) then
C            photon radiation
            process = trim(in3)//' -> '//outa
            call define_process_rcl(44,process,'LO')
            process = trim(in4)//' -> '//outa
            call define_process_rcl(45,process,'LO')
            end if

            if (sgbrems(0) .eq. 1) then
C            Gluon radiation
            process = trim(in3)//' -> '//outg
            call define_process_rcl(48,process,'LO')
            process = trim(in4)//' -> '//outg
            call define_process_rcl(49,process,'LO')
            end if

            if (spinc(0) .eq. 1) then
C            Photon 1 induced
            process = trim(in3a1)//' -> '//trim(out)//' '//out31
            call define_process_rcl(50,process,'LO')

            process = trim(in4a1)//' -> '//trim(out)//' '//out41
            call define_process_rcl(51,process,'LO')

C            Photon 2 induced
            process = trim(in3a2)//' -> '//trim(out)//' '//out32
            call define_process_rcl(54,process,'LO')
            process = trim(in4a2)//' -> '//trim(out)//' '//out42
            call define_process_rcl(55,process,'LO')

            if(selprocess .eq. 3) then
            call define_process_rcl(400,'u e- -> u e- ' //H,'LO')
            call define_process_rcl(401,'u~ e- -> u~ e- ' //H,'LO')
            call define_process_rcl(403,'u e+ -> u e+ ' //H,'LO')
            call define_process_rcl(404,'u~ e+ -> u~ e+ ' //H,'LO')
            call define_process_rcl(410,'d e- -> d e- ' //H,'LO')
            call define_process_rcl(411,'d~ e- -> d~ e- ' //H,'LO')
            call define_process_rcl(413,'d e+ -> d e+ ' //H,'LO')
            call define_process_rcl(414,'d~ e+ -> d~ e+ ' //H,'LO')
            end if
            end if

            if (sginc(0) .eq. 1) then
C            Gluon 1 induced
            process = trim(in3g1)//' -> '//trim(out)//' '//out31
            call define_process_rcl(58,process,'LO')
            process = trim(in4g1)//' -> '//trim(out)//' '//out41
            call define_process_rcl(59,process,'LO')

C            Gluon 2 induced
            process = trim(in3g2)//' -> '//trim(out)//' '//out32
            call define_process_rcl(62,process,'LO')
            process = trim(in4g2)//' -> '//trim(out)//' '//out42
            call define_process_rcl(63,process,'LO')
            end if

C            if (sweak .eq. 1) then
C            virtual ew corrections
            process = trim(in3)//' -> '//out
            call define_process_rcl(75,process,'NLO')
            call unselect_power_LoopAmpl_rcl(75,'QCD',2)
            process = trim(in4)//' -> '//out
            call define_process_rcl(76,process,'NLO')
            call unselect_power_LoopAmpl_rcl(76,'QCD',2)
C            end if

            if (sqcd .eq. 1) then
C            virtual qcd corrections
            process = trim(in3)//' -> '//out
            call define_process_rcl(77,process,'NLO')
            call unselect_power_LoopAmpl_rcl(77,'QED',5)
            process = trim(in4)//' -> '//out
            call define_process_rcl(78,process,'NLO')
            call unselect_power_LoopAmpl_rcl(78,'QED',5)
            end if

          end if

        end subroutine init_higgs_strahlung
