module quarklabels
  implicit none
  integer :: n_in_states
  integer :: in11, in12, in21, in22, in31, in32, in41, in42
  contains
  subroutine init_quarkindices(selprocess)
    integer, intent(in) :: selprocess
    ! selprocess 1,2 -> incoming quarks are different in kind
    if (selprocess .eq. 1) then
      n_in_states = 2
      in11 = -1  ! d~
      in12 = 2   ! u
      in21 = -3  ! s~
      in22 = 4   ! c
    else if (selprocess .eq. 2) then
      n_in_states = 2
      in11 = -2  ! u~
      in12 = 1   ! d
      in21 = -4  ! c~
      in22 = 3   ! s
    ! selprocess 3,4 -> incoming quarks are of same kind, but anti
    else if (selprocess .eq. 3 .or. selprocess .eq. 4) then
      n_in_states = 4
      in11 = -2
      in12 = 2
      in21 = -1
      in22 = 1
      in31 = -4
      in32 = 4
      in41 = -3
      in42 = 3
    end if
  end subroutine init_quarkindices
end module quarklabels
