module alphas_ct
  use class_particles
  use scalar_functions

  complex(dp) :: GC_2, GC_MI, GC_150, GC_7, GC_6, GC_146, GC_88, GC_196, GC_195&
                 , GC_194, GC_197, GC_192, GC_645, GC_80, GC_193, GC_198, GC_85&
                 , GC_411, GC_623
  complex(dp) :: T719
  complex(dp) :: dZdL, dZHh_MS, dZbR, dZsR, dZsL, dZcR, V_OS_Hveve_T2, dZuR,   &
                 dZHa, dZuL, dZcL, dZHl, dtHl_MS, dZg, dZbL, dZtL, dtHh,       &
                 dZHl_MS, dtHh_MS, dZgs, dZG0Ha_MS, V_OS_Hveve_T1, dZHh, dZdR, &
                 dZtR, dtHl, dMU, dMB, dMHH2, dZHhHl, dMHL2, dZG0Ha, dMC, dMT, &
                 dZHhHl_MS, dMS, dtHhHl_MDTS_fin, dMHA2, dZHaG0_MS, dZHlHh_MS, &
                 db_MS, dMD, dZHlHh, dZHaG0, db, da_MS, da
  complex(dp) :: dZgs_Nf5, dZgs_Nf6
contains

subroutine initct(DeltaUV)
  real(dp), intent(in) :: DeltaUV
  GC_2 = -2d0*cima*ee/3d0
  GC_MI = -cima
  GC_150 = -cima*cb*ydo1 - cima*sb*ydo2
  GC_7 = cima*gs
  GC_6 = -gs
  GC_146 = -cima*cb*ydo2 + cima*sb*ydo1
  GC_88 = cima*cw*ee/(2d0*sw) - cima*ee*sw/(6d0*cw)
  GC_196 = cima*cb*yup1 + cima*sb*yup2
  GC_195 = -sqrt(2d0)*cima*ca*yup1/2d0 - sqrt(2d0)*cima*sa*yup2/2d0
  GC_194 = sqrt(2d0)*cb*yup2/2d0 - sqrt(2d0)*sb*yup1/2d0
  GC_197 = -sqrt(2d0)*cb*yup1/2d0 - sqrt(2d0)*sb*yup2/2d0
  GC_192 = -sqrt(2d0)*cima*ca*yup2/2d0 + sqrt(2d0)*cima*sa*yup1/2d0
  GC_645 = -GC_6
  GC_80 = sqrt(2d0)*cima*ee/(2d0*sw)
  GC_193 = cima*cb*yup2 - cima*sb*yup1
  GC_198 = sqrt(2d0)*cb*yup1/2d0 + sqrt(2d0)*sb*yup2/2d0
  GC_85 = -2d0*cima*ee*sw/(3d0*cw)
  GC_411 = cima*gs
  GC_623 = -GC_194

  T719 = B0(cnul, cMT2_reg, cMT2_reg)

  dZgs_Nf5 = cone*real(-2d0*Nc*(-DeltaUV*GC_192**2d0*GC_7*sq2/(64d0*pi**2d0*Nc &
             ) - DeltaUV*GC_193**2d0*GC_7*sq2/(64d0*pi**2d0*Nc) - DeltaUV*     &
             GC_194*GC_623*GC_7*sq2/(64d0*pi**2d0*Nc) - DeltaUV*GC_195**2d0*   &
             GC_7*sq2/(64d0*pi**2d0*Nc) - DeltaUV*GC_196**2d0*GC_7*sq2/(64d0*pi&
             **2d0*Nc) - DeltaUV*GC_197*GC_198*GC_7*sq2/(64d0*pi**2d0*Nc) -    &
             DeltaUV*GC_2**2d0*GC_7*sq2/(32d0*pi**2d0*Nc) + 3d0*cima*DeltaUV*  &
             GC_6*GC_7**2d0*sq2**3d0/(128d0*pi**2d0) + DeltaUV*GC_7**3d0*sq2** &
             3d0/(128d0*pi**2d0*Nc**2d0) - DeltaUV*GC_7*GC_85**2d0*sq2/(32d0*pi&
             **2d0*Nc) - GC_7*sq2*(19d0*cima*DeltaUV*GC_6**2d0*Nc*sq2**2d0/(   &
             384d0*pi**2d0) + cima*DeltaUV*GC_645**2d0*Nc*sq2**2d0/(384d0*pi** &
             2d0) + 5d0*cima*DeltaUV*GC_7**2d0*sq2**2d0/(48d0*pi**2d0) + cima* &
             GC_7**2d0*T719*sq2**2d0/(48d0*pi**2d0))/(4d0*GC_MI*Nc) - GC_7*sq2 &
             *(GC_MI*(-cima*DeltaUV*GC_146**2d0/(64d0*pi**2d0) - cima*DeltaUV* &
             GC_150**2d0/(64d0*pi**2d0) + cima*DeltaUV*GC_193**2d0/(64d0*pi**  &
             2d0) + cima*DeltaUV*GC_196**2d0/(64d0*pi**2d0) - cima*DeltaUV*    &
             GC_80**2d0/(32d0*pi**2d0) + cima*DeltaUV*GC_85**2d0/(32d0*pi**2d0 &
             ) - cima*DeltaUV*GC_88**2d0/(32d0*pi**2d0))/2d0 - GC_MI*(-cima*   &
             DeltaUV*GC_146**2d0/(64d0*pi**2d0) - cima*DeltaUV*GC_150**2d0/(   &
             64d0*pi**2d0) - cima*DeltaUV*GC_192**2d0/(32d0*pi**2d0) - cima*   &
             DeltaUV*GC_193**2d0/(64d0*pi**2d0) - cima*DeltaUV*GC_194*GC_623/( &
             32d0*pi**2d0) - cima*DeltaUV*GC_195**2d0/(32d0*pi**2d0) - cima*   &
             DeltaUV*GC_196**2d0/(64d0*pi**2d0) - cima*DeltaUV*GC_197*GC_198/( &
             32d0*pi**2d0) - cima*DeltaUV*GC_2**2d0/(16d0*pi**2d0) - cima*     &
             DeltaUV*GC_7**2d0*Nc*sq2**2d0/(64d0*pi**2d0) + cima*DeltaUV*GC_7**&
             2d0*sq2**2d0/(64d0*pi**2d0*Nc) - cima*DeltaUV*GC_80**2d0/(32d0*pi &
             **2d0) - cima*DeltaUV*GC_85**2d0/(32d0*pi**2d0) - cima*DeltaUV*   &
             GC_88**2d0/(32d0*pi**2d0))/2d0)/(GC_MI**2d0*Nc))/(GC_411*sq2))
  dZgs_Nf6 = cone*real(-2d0*Nc*(-DeltaUV*GC_192**2d0*GC_7*sq2/(64d0*pi**2d0*Nc &
             ) - DeltaUV*GC_193**2d0*GC_7*sq2/(64d0*pi**2d0*Nc) - DeltaUV*     &
             GC_194*GC_623*GC_7*sq2/(64d0*pi**2d0*Nc) - DeltaUV*GC_195**2d0*   &
             GC_7*sq2/(64d0*pi**2d0*Nc) - DeltaUV*GC_196**2d0*GC_7*sq2/(64d0*pi&
             **2d0*Nc) - DeltaUV*GC_197*GC_198*GC_7*sq2/(64d0*pi**2d0*Nc) -    &
             DeltaUV*GC_2**2d0*GC_7*sq2/(32d0*pi**2d0*Nc) + 3d0*cima*DeltaUV*  &
             GC_6*GC_7**2d0*sq2**3d0/(128d0*pi**2d0) + DeltaUV*GC_7**3d0*sq2** &
             3d0/(128d0*pi**2d0*Nc**2d0) - DeltaUV*GC_7*GC_85**2d0*sq2/(32d0*pi&
             **2d0*Nc) - GC_7*sq2*(19d0*cima*DeltaUV*GC_6**2d0*Nc*sq2**2d0/(   &
             384d0*pi**2d0) + cima*DeltaUV*GC_645**2d0*Nc*sq2**2d0/(384d0*pi** &
             2d0) + cima*DeltaUV*GC_7**2d0*sq2**2d0/(8d0*pi**2d0))/(4d0*GC_MI* &
             Nc) - GC_7*sq2*(GC_MI*(-cima*DeltaUV*GC_146**2d0/(64d0*pi**2d0) - &
             cima*DeltaUV*GC_150**2d0/(64d0*pi**2d0) + cima*DeltaUV*GC_193**2d0&
             /(64d0*pi**2d0) + cima*DeltaUV*GC_196**2d0/(64d0*pi**2d0) - cima* &
             DeltaUV*GC_80**2d0/(32d0*pi**2d0) + cima*DeltaUV*GC_85**2d0/(32d0*&
             pi**2d0) - cima*DeltaUV*GC_88**2d0/(32d0*pi**2d0))/2d0 - GC_MI*(- &
             cima*DeltaUV*GC_146**2d0/(64d0*pi**2d0) - cima*DeltaUV*GC_150**2d0&
             /(64d0*pi**2d0) - cima*DeltaUV*GC_192**2d0/(32d0*pi**2d0) - cima* &
             DeltaUV*GC_193**2d0/(64d0*pi**2d0) - cima*DeltaUV*GC_194*GC_623/( &
             32d0*pi**2d0) - cima*DeltaUV*GC_195**2d0/(32d0*pi**2d0) - cima*   &
             DeltaUV*GC_196**2d0/(64d0*pi**2d0) - cima*DeltaUV*GC_197*GC_198/( &
             32d0*pi**2d0) - cima*DeltaUV*GC_2**2d0/(16d0*pi**2d0) - cima*     &
             DeltaUV*GC_7**2d0*Nc*sq2**2d0/(64d0*pi**2d0) + cima*DeltaUV*GC_7**&
             2d0*sq2**2d0/(64d0*pi**2d0*Nc) - cima*DeltaUV*GC_80**2d0/(32d0*pi &
             **2d0) - cima*DeltaUV*GC_85**2d0/(32d0*pi**2d0) - cima*DeltaUV*   &
             GC_88**2d0/(32d0*pi**2d0))/2d0)/(GC_MI**2d0*Nc))/(GC_411*sq2))
end subroutine initct
end module alphas_ct
